/* --------------------------------------------------------------  */
/* Martrixmultiplikation  c't/as Mai 2007                          */
/* --------------------------------------------------------------  */
#include <stdio.h>
#include <liblarge_matrix.h>
#include "sgemm_spu.h"

float A[DIM][DIM] __attribute__((aligned (128))); 
float B[DIM][DIM] __attribute__((aligned (128))); 
float C[DIM][DIM] __attribute__((aligned (128))); 


//C[i,j]=A[i,j]*B[i,j]+C[i,j] 

void matmulconst(void)
{
 short int i,j,k;
 for (i=0; i < DIMX; i++)  
  for ( j=0; j < DIMX; j++)
   for (k=0;k < DIMX; k++)    
    C[i][j] +=A[i][k]*B[k][j];
 }

int main(unsigned long long id)
{
  int r;
  short int i,j;

  for (i=0; i<DIMX;i++) 
   for(j=0; j<DIMX;j++) {
    A[i][j]=i+j;
    B[i][j]=2;
    C[i][j]=0;
  }

 for (r=0; r < REP; r++)  madd_matrix_matrix (DIMX,DIMX,DIMX,A,DIM,B,DIM,C,DIM);
     //matmulconst();
 printf("ok,V1.0 done (0x%llx) C[2,2]=%f C[10,10]= %f\n", id, C[2][2], C[10][10]);
 return 0;
}
